#property copyright "*"
#property link      "*"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Red
#property indicator_color2 DodgerBlue
#property indicator_color3 Red
#property indicator_color4 DodgerBlue
#property indicator_color5 Red
#property indicator_color6 DodgerBlue
#property indicator_color7 Red
#property indicator_color8 DodgerBlue

#property indicator_width1 4
#property indicator_width2 4

#property indicator_width3 3
#property indicator_width4 3

#property indicator_width5 2
#property indicator_width5 2

#property indicator_width6 1
#property indicator_width7 1

//---- input parameters
extern   bool     Sh1=true;
extern   bool     Sh2=true;
extern   bool     Sh3=true;
extern   bool     Sh4=true;
extern   double   k1=1.0;
extern   double   k2=3.0;
extern   double   k3=6.0;
extern   double   k4=24.0;

extern   int      FromAr1=10;
extern   int      FromAr2=15;
extern   int      FromAr3=20;
extern   int      FromAr4=25;



extern int Pr=0;

//---- buffers

double A1[];
double A2[];
double A3[];
double A4[];
double A5[];
double A6[];
double A7[];
double A8[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW,0,4);
   SetIndexArrow(0,143);
   SetIndexBuffer(0,A1);
   SetIndexStyle(1,DRAW_ARROW,0,4);
   SetIndexArrow(1,143);
   SetIndexBuffer(1,A2);
   
   SetIndexStyle(2,DRAW_ARROW,0,3);
   SetIndexArrow(2,142);
   SetIndexBuffer(2,A3);
   SetIndexStyle(3,DRAW_ARROW,0,3);
   SetIndexArrow(3,142);
   SetIndexBuffer(3,A4);   
   
   SetIndexStyle(4,DRAW_ARROW,0,2);
   SetIndexArrow(4,141);
   SetIndexBuffer(4,A5);
   SetIndexStyle(5,DRAW_ARROW,0,2);
   SetIndexArrow(5,141);
   SetIndexBuffer(5,A6);   
   
   SetIndexStyle(6,DRAW_ARROW,0,1);
   SetIndexArrow(6,140);
   SetIndexBuffer(6,A7);
   SetIndexStyle(7,DRAW_ARROW,0,1);
   SetIndexArrow(7,140);
   SetIndexBuffer(7,A8);   
   
   
   SetIndexLabel(0,"GMA Quadro");
   SetIndexLabel(1,"GMA Quadro");   
   SetIndexLabel(2,"GMA Quadro");   
   SetIndexLabel(3,"GMA Quadro"); 
   SetIndexLabel(4,"GMA Quadro");
   SetIndexLabel(5,"GMA Quadro");   
   SetIndexLabel(6,"GMA Quadro");   
   SetIndexLabel(7,"GMA Quadro");    
   
     
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){
  double m;
  double c,p;
   int limit=Bars-IndicatorCounted();
      for(int i=limit-1;i>=0;i--){
         A1[i]=EMPTY_VALUE;
         A2[i]=EMPTY_VALUE;         
         A3[i]=EMPTY_VALUE;         
         A4[i]=EMPTY_VALUE;         
         A5[i]=EMPTY_VALUE;
         A6[i]=EMPTY_VALUE;         
         A7[i]=EMPTY_VALUE;         
         A8[i]=EMPTY_VALUE;         
            if(Sh1){
               c=IndVal(k1,i);
               p=IndVal(k1,i+1);
                  if(c>0 && p<=0)A7[i]=Low[i]-Point*FromAr1;
                  if(c<0 && p>=0)A8[i]=High[i]+Point*FromAr1;                  
            }
            if(Sh2){
               c=IndVal(k2,i);
               p=IndVal(k2,i+1);
                  if(c>0 && p<=0)A5[i]=Low[i]-Point*FromAr2;
                  if(c<0 && p>=0)A6[i]=High[i]+Point*FromAr2;                  
            }            
            if(Sh3){
               c=IndVal(k3,i);
               p=IndVal(k3,i+1);
                  if(c>0 && p<=0)A3[i]=Low[i]-Point*FromAr3;
                  if(c<0 && p>=0)A4[i]=High[i]+Point*FromAr3;                  
            }            
            if(Sh4){
               c=IndVal(k4,i);
               p=IndVal(k4,i+1);
                  if(c>0 && p<=0)A1[i]=Low[i]-Point*FromAr4;
                  if(c<0 && p>=0)A2[i]=High[i]+Point*FromAr4;                  
            }            
      }
   return(0);
  }
//+------------------------------------------------------------------+

double IndVal(double Koef,int Ind){
   double c=0;
   double m=0;
      m=iMACD(NULL,0,Koef*3,Koef*30,9,Pr,MODE_MAIN,Ind);
         if(m>0)c++;
         if(m<0)c--;         
      m=iMACD(NULL,0,Koef*5,Koef*35,9,Pr,MODE_MAIN,Ind);
         if(m>0)c++;
         if(m<0)c--;                    
      m=iMACD(NULL,0,Koef*8,Koef*40,9,Pr,MODE_MAIN,Ind);
         if(m>0)c++;
         if(m<0)c--;          
      m=iMACD(NULL,0,Koef*10,Koef*45,9,Pr,MODE_MAIN,Ind);
         if(m>0)c++;
         if(m<0)c--;   
      m=iMACD(NULL,0,Koef*12,Koef*50,9,Pr,MODE_MAIN,Ind);
         if(m>0)c++;
         if(m<0)c--;
      m=iMACD(NULL,0,Koef*15,Koef*60,9,Pr,MODE_MAIN,Ind);
         if(m>0)c++;
         if(m<0)c--;
   return(c);
}